﻿package myclass.display{
	import flash.display.Graphics;
	public class RectDraw extends BasicDraw{
		private var _width:Number;
		private var _height:Number;
		private var _ellipseWidth:Number;
		private var _ellipseHeight:Number;
		public function RectDraw(width:Number=100, height:Number=100, ellipseWidth:Number=0, ellipseHeight:Number=0){
			_width = width;
			_height = height;
			_ellipseWidth = ellipseWidth;
			_ellipseHeight = ellipseHeight;
			drawing();
		}
		
		override public function drawing():void{
			var g:Graphics = this.graphics;
			g.clear();
			if(lineThickness){
				g.lineStyle(lineThickness, lineColor, lineAlpha, true);
			}
			g.beginFill(fillColor,fillAlpha);
			g.drawRoundRect(0, 0, _width, _height, _ellipseWidth, _ellipseHeight);
			g.endFill();		
		}
		
		public function set ellipseWidth(value:Number) : void
		{
			_ellipseWidth = value;
			drawing();
		}
		public function get ellipseWidth() : Number
		{
			return  _ellipseWidth;
		}
		
		public function set ellipseHeight(value:Number) : void
		{
			_ellipseHeight = value;
			drawing();
		}
		public function get ellipseHeight() : Number
		{
			return  _ellipseHeight;
		}
		
		override public function  set  width(value:Number) : void
		{
			_width = value;
			drawing();
		}
		override public function get width() : Number
		{
			return  _width;
		}
		
		override public function  set height(value:Number) : void
		{
			_height = value;
			drawing();
		}
		override public function get height() : Number
		{
			return _height;
		}
		
	}
}










