﻿package {
	//Tweener를 비롯하여 Depth1Menu클래스에 필요한 클래스를 import시켜줍니다.
	import caurina.transitions.*;
	import caurina.transitions.properties.*;
	import flash.text.TextField;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	//Depth1Menu클래스는 BasicMenu클래스를 상속 받습니다.
	public class Depth1Menu extends BasicMenu{
		//텍스트 객체 menuText를 생성합니다.
		//2뎁스 메뉴들을 묶어줄 depth2Group객체를 생성합니다.
		//fla파일에서 생성한 mc_arrow클래스의 mcArrow객체를 생성합니다.		
		//링크주소를 저장할 String변수 _urlStr을 생성합니다. 
		//메뉴에 나타낼 String변수 _nameStr을 생성합니다
		//Tweener로 모션을 제어할때 사용할 time값 Number변수 _tweenTime을 생성하여 0.5로 지정하였습니다.
		//Tweener로 모션을 제어할때 사용할 transition값 String변수 _transition을 생성하여 "easeInOut"으로 지정하였습니다.
		public var menuText:MenuText = new MenuText();
		public var depth2Group:Depth2MenuGroup = new Depth2MenuGroup;
		private var mcArrow:mc_arrow = new mc_arrow();		
		public var _urlStr:String;
		public var _nameStr:String = "";		
		private var _tweenTime:Number = 0.5;
		private var _transition:String = "easeInOut";
				
		function Depth1Menu(){
			//Depth1Menu객체에 마우스오버했을때  depth1over메서드를 실행합니다.
			//Depth1Menu객체에 마우스아웃했을때  depth1out메서드를 실행합니다.
			//Depth1Menu객체에 마우스클릭했을때  depth1click메서드를 실행합니다.
			//Depth1Menu객체에 menuText를 추가하여 화면에 보여줍니다.			
			//Depth1Menu객체에 depth2Group을 추가하여 화면에 보여줍니다.		
			//mcArrow객체의 투명도를 0으로 지정합니다.
			//Depth1Menu객체에 mcArrow 추가하여 화면에 보여줍니다.(투명도가 0으로 설정되어있어 보이지는않지만 존재합니다)
			this.overAction = depth1over;
			this.outAction = depth1out;
			this.clickAction = depth1click;
			this.addChild(menuText);
			this.addChild(depth2Group);
			mcArrow.alpha = 0;			
			this.addChild(mcArrow);
		}
		//setter, getter을 이용하여 Depth2Menu클래스의 메뉴에 나타낼 String값을 외부에서 nameStr메서드를 통해 입력할 수 있습니다.
		public function set nameStr(value:String):void{
			_nameStr = value;
			menuText.str = _nameStr;
			menuText.x = Math.ceil((this.width - menuText.width)/2);
			menuText.y = Math.ceil((this.height - menuText.height)/2);
			mcArrow.x = Math.ceil(menuText.x + menuText.width + 5);
			mcArrow.y = Math.ceil((this.height - mcArrow.height)/2);
		}
		public function get nameStr():String{
			return _nameStr;
		}
		private function depth1over(evt:MouseEvent):void{
			depth1overAction();
		}
		private function depth1out(evt:MouseEvent):void{
			depth1outAction();
		}
		private function depth1click(evt:MouseEvent):void{
			depth1clickAction();
		}
		//mcArrow의 alpha값은 _tweenTime시간동안 _transition의 속도로 1이 됩니다.
		//menuText의 alpha값은 _tweenTime시간동안 _transition의 속도로 0.7이 됩니다.
		//depth2Group의 groupView메서드를 실행합니다.
		public function depth1overAction(){			
			Tweener.addTween(mcArrow, {alpha:1, time:_tweenTime, transition:_transition});
			Tweener.addTween(menuText, {alpha:0.7, time:_tweenTime, transition:_transition});
			depth2Group.groupView();
		}
		//mcArrow의 alpha값은 _tweenTime시간동안 _transition의 속도로 0이 됩니다.
		//menuText의 alpha값은 _tweenTime시간동안 _transition의 속도로 1이 됩니다.
		//depth2Group의 groupHide메서드를 실행합니다.
		public function depth1outAction(){
			Tweener.addTween(mcArrow, {alpha:0, time:_tweenTime, transition:_transition});
			Tweener.addTween(menuText, {alpha:1, time:_tweenTime, transition:_transition});
			depth2Group.groupHide();
		}
		public function depth1clickAction(){
			var request:URLRequest = new URLRequest(_urlStr);
			navigateToURL(request, "_self");
		}		
	}
}
