﻿package {
	//Tweener를 비롯하여 Depth2Menu클래스에 필요한 클래스를 import시켜줍니다.
	import caurina.transitions.*;
	import caurina.transitions.properties.*;
	import flash.events.MouseEvent;
	import flash.net.URLRequest;
	import flash.net.navigateToURL;
	//Depth2Menu클래스는 BasicMenu클래스를 상속 받습니다.
	public class Depth2Menu extends BasicMenu{
		//마우스오버에 나타날 텍스트 객체 menuTextOver를 생성합니다.
		//마우스아웃에 나타날 텍스트 객체 menuTextOut을 생성합니다.
		//링크주소를 저장할 String변수 _urlStr을 생성합니다. 
		//메뉴에 나타낼 String변수 _nameStr을 생성합니다
		//Tweener로 모션을 제어할때 사용할 time값 Number변수 _tweenTime을 생성하여 0.5로 지정하였습니다.
		//Tweener로 모션을 제어할때 사용할 transition값 String변수 _transition을 생성하여 "easeInOut"으로 지정하였습니다.
		public var menuTextOver:MenuText = new MenuText();
		public var menuTextOut:MenuText = new MenuText();		
		public var _urlStr:String;
		private var _nameStr:String = "";
		private var _tweenTime:Number = 0.5;
		private var _transition:String = "easeInOut";
		
		function Depth2Menu(){
			//Depth2Menu객체에 마우스오버했을때  depth2over메서드를 실행합니다.
			//Depth2Menu객체에 마우스아웃했을때  depth2out메서드를 실행합니다.
			//Depth2Menu객체에 마우스클릭했을때  depth2click메서드를 실행합니다.
			//Depth2Menu객체에 menuTextOver를 추가하여 화면에 보여줍니다.			
			//Depth2Menu객체에 menuTextOut을 추가하여 화면에 보여줍니다.			
			this.overAction = depth2over;
			this.outAction = depth2out;
			this.clickAction = depth2click;
			this.addChild(menuTextOver);
			this.addChild(menuTextOut);
		}
		//setter, getter을 이용하여 Depth2Menu클래스의 메뉴에 나타낼 String값을 외부에서 nameStr메서드를 통해 입력할 수 있습니다.
		public function set nameStr(value:String):void{
			_nameStr = value;
			menuTextOver.str = _nameStr;
			menuTextOut.str = _nameStr;
			menuTextOver.x = 5;
			menuTextOver.y = (this.height - menuTextOver.height)/2;
			menuTextOut.x = 5;
			menuTextOut.y = (this.height - menuTextOut.height)/2;		
		}
		public function get nameStr():String{
			return _nameStr;
		}
		private function depth2over(evt:MouseEvent):void{
			depth2overAction();
		}
		private function depth2out(evt:MouseEvent):void{
			depth2outAction();
		}
		private function depth2click(evt:MouseEvent):void{
			depth2clickAction();
		}
		//menuTextOver의 alpha값은 _tweenTime시간동안 _transition의 속도로 1이 됩니다.
		//menuTextOut의 alpha값은 _tweenTime시간동안 _transition의 속도로 0이 됩니다.
		public function depth2overAction():void{
			Tweener.addTween
			(menuTextOver, {alpha:1, time:_tweenTime, transition:_transition});
			Tweener.addTween
			(menuTextOut, {alpha:0, time:_tweenTime, transition:_transition});
		}
		//menuTextOver의 alpha값은 _tweenTime시간동안 _transition의 속도로 0이 됩니다.
		//menuTextOut의 alpha값은 _tweenTime시간동안 _transition의 속도로 1이 됩니다.
		public function depth2outAction():void{
			Tweener.addTween
			(menuTextOver, {alpha:0, time:_tweenTime, transition:_transition});
			Tweener.addTween
			(menuTextOut, {alpha:1, time:_tweenTime, transition:_transition});			
		}
		//URLRequest 클래스로 request객체를 _urlStr값으로 생성합니다.
		//_urlStr값으로 기존의  웹브라우즈 창을 띄워줍니다.
		public function depth2clickAction():void{
			var request:URLRequest = new URLRequest(_urlStr);
			navigateToURL(request, "_self");
		}		
	}
}
