﻿package {
	//Depth2MenuGroup클래스에 필요한 클래스를 import시켜줍니다
	import myclass.display.RectDraw;
	import caurina.transitions.*;
	import caurina.transitions.properties.*;
	import flash.display.Sprite;	
	//Depth2MenuGroup클래스는 Sprite클래스를 상속 받습니다.
	public class Depth2MenuGroup extends Sprite{
		//마스크로 사용할 RectDraw클래스의 groupmask객체를 생성합니다.
		//배경이미지로 사용할 RectDraw클래스의 groupbg객체를 생성합니다.
		//Tweener로 모션을 제어할때 사용할 time값 Number변수 _tweenTime을 생성하여 0.5로 지정하였습니다.
		//Tweener로 모션을 제어할때 사용할 transition값 String변수 _transition을 생성하여 "Strong.easeInOut"으로 지정하였습니다.		
		public var groupmask = new RectDraw();
		public var groupbg = new RectDraw();		
		private var _tweenTime:Number = 0.5;
		private var _transition:String = "Strong.easeInOut";
		//Depth2Menu객체에 groupmask를 추가하여 화면에 보여줍니다.
		//Depth2Menu객체에 groupbg를 추가하여 화면에 보여줍니다.
		//groupbg에 groupmask의 마스크를 씌워 groupmask영역만큼만 groupbg를 보여줍니다.
		function Depth2MenuGroup(){			
			addChild(groupmask);
			addChild(groupbg);
			groupbg.mask = groupmask;
		}
		//groupbg의 y값은 _tweenTime시간동안 _transition의 속도로 0이 됩니다.
		public function groupView(){
			Tweener.addTween(groupbg, {y:0, time:_tweenTime, transition:_transition});			
		}		
		//groupbg의 y값은 _tweenTime시간동안 _transition의 속도로 -groupbg.height - groupbg.lineThickness이 됩니다.
		public function groupHide(){
			Tweener.addTween(groupbg, {y:-groupbg.height - groupbg.lineThickness, time:_tweenTime, transition:_transition});
		}
	}
}