﻿package {
	//text패키지 하위의 모든 클래스를 import 시켜줍니다
	//Sprite클래스를 import 시켜줍니다
	import flash.text.*;  
	import flash.display.Sprite; 
	//MenuText클래스는 Sprite클래스를 상속 받습니다.
	class MenuText extends Sprite{
		//TextField를 txt객체로 생성합니다
		//String변수 _str을 생성합니다
		//Number변수 _color를 생성합니다		
		public var txt:TextField = new TextField();		
		private var _str:String;
		private var _color:Number = 0x555555;		
		//txt의 입력된 글자를 선택할수 없게 selectable속성값을 false설정합니다.
		//txt의 autoSize속성값을 "left"로 설정하여 좌측을 기준으로 autoSize되게 합니다.
		//MenuText클래스의 객체는 마우스 기능을 사용할수 없게 mouseChildren속성을 false로 설정합니다.
		//MenuText클래스의 DisplayObjectContainer에 txt추가하여 화면에 보여줍니다.
		function MenuText(){
			txt.selectable = false;
			txt.autoSize = "left";			
			this.mouseChildren = false;
			addChild(txt);			
		}
		//setter, getter을 이용하여 MenuText클래스의 텍스트 색깔을 외부에서 colo메서드를 통해 입력할 수 있습니다.
		public function set color(value:Number):void{
			_color = value;
			txt.textColor = _color;			
		}
		public function get color():Number{
			return _color;
		}
		//setter, getter을 이용하여 MenuText클래스의 출력할 텍스트값을 외부에서 str메서드를 통해 입력할 수 있습니다.
		public function set str(value:String):void{
			_str = value;
			txt.text = _str;
		}
		public function get str():String{
			return _str;
		}
	}
}
